blob: a8c6517bcebb42ad2f54306b52cc46756ac459e6 [file] [log] [blame]
Josh Coalson60d9d012001-05-27 18:32:15 +00001#!/bin/sh
2
Josh Coalson6b05bc52001-06-08 00:13:21 +00003# FLAC - Free Lossless Audio Codec
Josh Coalsone74bd952007-02-02 06:58:19 +00004# Copyright (C) 2001,2002,2003,2004,2005,2006,2007 Josh Coalson
Josh Coalson6b05bc52001-06-08 00:13:21 +00005#
Josh Coalsone8a76012003-02-07 00:14:32 +00006# This file is part the FLAC project. FLAC is comprised of several
7# components distributed under difference licenses. The codec libraries
8# are distributed under Xiph.Org's BSD-like license (see the file
9# COPYING.Xiph in this distribution). All other programs, libraries, and
10# plugins are distributed under the GPL (see COPYING.GPL). The documentation
11# is distributed under the Gnu FDL (see COPYING.FDL). Each file in the
12# FLAC distribution contains at the top the terms under which it may be
13# distributed.
Josh Coalson6b05bc52001-06-08 00:13:21 +000014#
Josh Coalsone8a76012003-02-07 00:14:32 +000015# Since this particular file is relevant to all components of FLAC,
16# it may be distributed under the Xiph.Org license, which is the least
17# restrictive of those mentioned above. See the file COPYING.Xiph in this
18# distribution.
Josh Coalson6b05bc52001-06-08 00:13:21 +000019
Josh Coalson6218b342002-12-12 03:58:18 +000020die ()
21{
22 echo $* 1>&2
23 exit 1
24}
25
Josh Coalsonb43d3cb2004-11-09 01:28:05 +000026if [ x = x"$1" ] ; then
27 BUILD=debug
28else
29 BUILD="$1"
30fi
31
32LD_LIBRARY_PATH=../src/libFLAC/.libs:$LD_LIBRARY_PATH
Josh Coalsonb43d3cb2004-11-09 01:28:05 +000033LD_LIBRARY_PATH=../src/share/grabbag/.libs:$LD_LIBRARY_PATH
34LD_LIBRARY_PATH=../src/share/getopt/.libs:$LD_LIBRARY_PATH
35LD_LIBRARY_PATH=../src/share/replaygain_analysis/.libs:$LD_LIBRARY_PATH
36LD_LIBRARY_PATH=../src/share/replaygain_synthesis/.libs:$LD_LIBRARY_PATH
37LD_LIBRARY_PATH=../src/share/utf8/.libs:$LD_LIBRARY_PATH
38LD_LIBRARY_PATH=../obj/$BUILD/lib:$LD_LIBRARY_PATH
Josh Coalson60d9d012001-05-27 18:32:15 +000039export LD_LIBRARY_PATH
Josh Coalsonb43d3cb2004-11-09 01:28:05 +000040PATH=../src/flac:$PATH
41PATH=../obj/$BUILD/bin:$PATH
Josh Coalson60d9d012001-05-27 18:32:15 +000042BINS_PATH=../../test_files/bins
43
Josh Coalson4ac9fdb2006-11-02 01:38:55 +000044if [ x"$FLAC__TEST_LEVEL" = x ] ; then
45 FLAC__TEST_LEVEL=1
46fi
47
Josh Coalson6218b342002-12-12 03:58:18 +000048flac --help 1>/dev/null 2>/dev/null || die "ERROR can't find flac executable"
Josh Coalson94b22e02002-10-11 06:22:30 +000049
Josh Coalson34c1ea82002-12-04 04:57:33 +000050run_flac ()
51{
Josh Coalsonde9091e2006-05-25 02:48:22 +000052 if [ x"$FLAC__TEST_WITH_VALGRIND" = xyes ] ; then
Josh Coalson338a0b12006-11-20 05:39:34 +000053 echo "valgrind --leak-check=yes --show-reachable=yes --num-callers=100 flac $*" >>test_bins.valgrind.log
Josh Coalson80936c52002-12-30 23:31:47 +000054 valgrind --leak-check=yes --show-reachable=yes --num-callers=100 --logfile-fd=4 flac $* 4>>test_bins.valgrind.log
Josh Coalson34c1ea82002-12-04 04:57:33 +000055 else
56 flac $*
57 fi
58}
Josh Coalson94b22e02002-10-11 06:22:30 +000059
Josh Coalson21f692b2001-07-22 07:25:50 +000060test -d ${BINS_PATH} || exit 77
61
Josh Coalson60d9d012001-05-27 18:32:15 +000062test_file ()
63{
64 name=$1
65 channels=$2
66 bps=$3
67 encode_options="$4"
68
Josh Coalson53677592004-10-01 16:44:10 +000069 echo -n "$name.bin (--channels=$channels --bps=$bps $encode_options): encode..."
Josh Coalson5ebd6932006-11-17 06:03:18 +000070 cmd="run_flac --verify --silent --force --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options --no-padding $name.bin"
Josh Coalson60d9d012001-05-27 18:32:15 +000071 echo "### ENCODE $name #######################################################" >> ./streams.log
72 echo "### cmd=$cmd" >> ./streams.log
Josh Coalson6218b342002-12-12 03:58:18 +000073 $cmd 2>>./streams.log || die "ERROR during encode of $name"
74
Josh Coalson60d9d012001-05-27 18:32:15 +000075 echo -n "decode..."
Josh Coalsonba56c9e2004-07-17 00:22:39 +000076 cmd="run_flac --silent --force --endian=big --sign=signed --decode --force-raw-format $name.flac";
Josh Coalson60d9d012001-05-27 18:32:15 +000077 echo "### DECODE $name #######################################################" >> ./streams.log
78 echo "### cmd=$cmd" >> ./streams.log
Josh Coalson6218b342002-12-12 03:58:18 +000079 $cmd 2>>./streams.log || die "ERROR during decode of $name"
80
Josh Coalson60d9d012001-05-27 18:32:15 +000081 ls -1l $name.bin >> ./streams.log
82 ls -1l $name.flac >> ./streams.log
83 ls -1l $name.raw >> ./streams.log
Josh Coalson6218b342002-12-12 03:58:18 +000084
Josh Coalson60d9d012001-05-27 18:32:15 +000085 echo -n "compare..."
Josh Coalson6218b342002-12-12 03:58:18 +000086 cmp $name.bin $name.raw || die "ERROR during compare of $name"
87
Josh Coalson60d9d012001-05-27 18:32:15 +000088 echo OK
89}
90
91echo "Testing bins..."
Josh Coalson94b22e02002-10-11 06:22:30 +000092for f in b00 b01 b02 b03 b04 ; do
Josh Coalson53677592004-10-01 16:44:10 +000093 binfile=$BINS_PATH/$f
94 if [ -f $binfile.bin ] ; then
Josh Coalson94b22e02002-10-11 06:22:30 +000095 for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
96 for channels in 1 2 4 8 ; do
97 for bps in 8 16 24 ; do
98 for opt in 0 1 2 4 5 6 8 ; do
99 for extras in '' '-p' '-e' ; do
100 for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
101 test_file $binfile $channels $bps "-$opt $extras $blocksize $disable"
102 done
103 done
Josh Coalson60d9d012001-05-27 18:32:15 +0000104 done
Josh Coalsonde9091e2006-05-25 02:48:22 +0000105 if [ "$FLAC__TEST_LEVEL" -gt 1 ] ; then
Josh Coalson83d91422006-11-10 05:15:23 +0000106 test_file $binfile $channels $bps "--lax -b 16384 -m -r 8 -l 32 -e -p $disable"
Josh Coalson94b22e02002-10-11 06:22:30 +0000107 fi
Josh Coalson60d9d012001-05-27 18:32:15 +0000108 done
109 done
Josh Coalson60d9d012001-05-27 18:32:15 +0000110 done
Josh Coalson94b22e02002-10-11 06:22:30 +0000111 else
112 echo "$binfile not found, skipping."
113 fi
Josh Coalson60d9d012001-05-27 18:32:15 +0000114done